# graphql-codegen-plugin-typescript-swr-ramiel <!-- omit in toc -->

## WARNING <!-- omit in toc -->

This is a fork of [graphql-codegen-plugin-typescript-swr](https://github.com/croutonn/graphql-codegen-plugin-typescript-swr) to enable some features, waiting
for these features to be available in the original package in any form. This is not proposed as PR because the code is not mature enough.

## Install

`npm install graphql-codegen-plugin-typescript-swr-ramiel`

What can you do?

## Skip queries

You can skip a request

```ts
const result = sdk.useMyQuery(
  {
    eventId: eventId as string,
  },
  {
    // if this is true, the query is not executed
    // if this value becomes false, the query is executed
    skip: isConditionToSkipMet,
    // ...normal options goes here
  }
)
```

## Customize auto generated key

Even if the key is autogenerated, it can be overwritten)

```ts
import type { Key } from 'swr'

//Let you create a function to override the generated key
const customKey = useCallback(
  (key: Key) => {
    if (admin) return [...key, 'admin']

    return key
  },
  [admin]
)

const result = sdk.useMyQuery(
  {
    eventId: eventId as string,
  },
  {
    // pass the callback to override the key
    customKey: customKey,
    // ...normal options goes here
  }
)
```

## Loading status

Loading state is now part of the result.  
**note** that loading is always false if the query is skipped

```ts
const { loading, data, error } = sdk.useMyQuery({
  eventId: eventId as string,
})
```
